@Make(Text) @Style(Size 11, BottomMargin 0)

@blankspace(-5lines)
@Heading(A Grossberg-to-English Dictionary)

@Begin[Description, LeftMargin +18, Indent -18]

STM trace@\``Short term memory'':  an activity pattern.

LTM trace@\``Long term memory'':  a set of weights.

unlearned@\Built in; hardwired.

spatially distributed activity pattern@\An activity pattern.  (The point is
that the activation is distributed across a collection of units that
function simultaneously, analogous to a region of brain tissue.)

unitizing; global grouping@\Winner-take-all competitive behavior.

recognition code@\A familiar pattern; a learned class or category; an
output state of a classifier.

self-organize@\Automatically group patterns into classes.

self-stabilize@\Learn pattern classes from examples without suffering
distortion due to noisy inputs, unequal repetition rates, or weight
saturation.

self-scale@\Make the attention paid to individual features be inversely
proportional to the total number of features in the pattern.  This way, a
mismatch of a single feature will have more effect in patterns with only a
few features.

self-adjusting search@\Serial search.  Cumulatively inhibit false
retrievals until the correct ``winner'' is found.

self-ordering search@\Search where the best-matching candidates are tried first.

direct access@\Getting the answer right the first time.  The ``correct''
recognition category (i.e., output node) is the most highly activated, so it
wins the first competition.

global signal; non-specific signal@\A signal sent to every unit in the
module, rather than to specific ones

2/3 rule@\An implementation trick for intersecting two activity patterns.
Use units with a threshold of 2.  Present the first pattern and use a
global excitatory signal to fill in while waiting for the second pattern.
When the second pattern shows up and provides additional input to the
units, remove the global excitatory signal.  Units that remain active are
in the intersection of the two patterns.  In total there are three signals
involved, at least two of which must always be present for the intersection
units to remain active.  This is the 2/3 part; there is no ``rule''.

dipole field@\A winner-take-all network in which units can be selectively hit
with long term inhibition, removing them from future competitions.

arousal burst; reset wave@\A global reset signal causing long term
inhibition of any dipole field unit that is active after a false retrieval.

orienting subsystem@\A mechanism for triggering the reset wave when the
retrieved pattern does not match the input well enough.

vigilance@\Amount of sensitivity to mismatch between the input pattern and
the nearest learned pattern, expresseed as a percentage of the number of
features in the input.  A vigilance setting of 0.9 means 90% of the
features must match.

match tracking@\A technique for correcting faulty classifier responses.
When the selected output class is incorrect, the vigilance parameter is
raised just high enough to prevent the winning node from firing.  Then the
match is tried again.

@End[Description]
